#ifndef BACK_ASSIGN_ALPHABETIZED_H
#define BACK_ASSIGN_ALPHABETIZED_H

#include <iostream>

#include "ir2det_monitor.h"

namespace mm {
  namespace ir_visitors {

class back_assign_alphabetized_visitor : public ir2det_monitor {

 public:
  // Constructor
  back_assign_alphabetized_visitor(global_params*,
				   monitor_params*,
				   std::ostream&,
				   std::ostream&);
  // Destructor
  virtual ~back_assign_alphabetized_visitor();
  
  virtual void begin(intermediate_rep* automaton);
  virtual void process_state(state_t* state);
  virtual void process_outgoing(transition_t* trans);
  virtual void process_incoming(transition_t* trans);
  virtual void end();

 protected:
  void step_footer();
  
 private:
  bool disjunction_needed;
  int accept_all_state_id;
  int active_state;
  bool elseif_needed;
};




  } // namespace ir_visitors
} // namespace mm

#endif
