#ifndef FRONT_DET_ASSIGN_ALPHABETIZED_EXPLICIT_TABLE_H
#define FRONT_DET_ASSIGN_ALPHABETIZED_EXPLICIT_TABLE_H

#include <iostream>

#include "ir2det_monitor.h"
#include "utils.h"


namespace mm {
  namespace ir_visitors {

/**
 * 
 */
class front_det_assign_alphabetized_explicit_table_visitor : public ir2det_monitor {

 public:
  // Constructor
  front_det_assign_alphabetized_explicit_table_visitor(global_params*,
					       monitor_params*,
					       std::ostream&,
					       std::ostream&);
  // Destructor
  virtual ~front_det_assign_alphabetized_explicit_table_visitor();
  
  virtual void begin(intermediate_rep* automaton);
  virtual void process_state(state_t* state);
  virtual void process_outgoing(transition_t* trans);
  virtual void process_incoming(transition_t* trans);
  virtual void end();
  
 private:
  int current_state;
  unsigned alphabet_size;
  int** transition_table;
};



 
  } // namespace ir_visitors
} // namespace mm

#endif
