#ifndef FRONT_DET_ASSIGN_ALPHABETIZED_SWITCH_H
#define FRONT_DET_ASSIGN_ALPHABETIZED_SWITCH_H

#include <iostream>

#include "ir2det_monitor.h"

namespace mm {
  namespace ir_visitors {

/**
 * 
 */
class front_det_assign_alphabetized_switch_visitor : public ir2det_monitor {

 public:
  // Constructor
  front_det_assign_alphabetized_switch_visitor(global_params*,
					       monitor_params*,
					       std::ostream&,
					       std::ostream&);
  // Destructor
  virtual ~front_det_assign_alphabetized_switch_visitor();
  
  virtual void begin(intermediate_rep* automaton);
  virtual void process_state(state_t* state);
  virtual void process_outgoing(transition_t* trans);
  virtual void process_incoming(transition_t* trans);
  virtual void end();

 protected:
  void step_footer();
  
 private:
  bool t_switch_needed;
  bool closing_brace_for_if_needed;
  bool closing_brace_for_switch_needed;
  bool start_outer_switch;
};



 
  } // namespace ir_visitors
} // namespace mm

#endif
